#pragma semicolon 1

#include <sourcemod>

#define	REQUIRE_PLUGIN
#include <activity_history>

public Plugin:myinfo = 
{
	name	= "Activity History [Log]",
	author	= "wS",
	version = "1.0.2"
};

new Handle:g_hFile			 = INVALID_HANDLE;	// Если != INVALID_HANDLE, то запрос не завершен.
new Handle:g_hIgnoreDateTrie = INVALID_HANDLE;	// Лог за этот день уже создавали
new String:g_sFilePath[PLATFORM_MAX_PATH];		// Путь к последнему открытому g_hFile
new g_AdminId;
new bool:g_bAfterCmd;							// true = лог создаётся командой ah_log, false = автоматом за прошлый день.
new Handle:g_hAH_OnLogCreated;

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_hAH_OnLogCreated = CreateGlobalForward("AH_OnLogCreated", ET_Ignore, Param_String, Param_Cell);
	RegPluginLibrary("ah_log");
	return APLRes_Success;
}

public OnPluginStart()
{
	if (g_hIgnoreDateTrie != INVALID_HANDLE) {
		return;
	}
	
	g_hIgnoreDateTrie = CreateTrie();
	
	CreateDirectory("cfg/activity_history", 511);
	CreateDirectory("cfg/activity_history/log", 511);
	
	TryCreateLog();
	
	AH_HookEvent(AH_EVENT_SQL, OnSqlStatusChanged, true);
	AH_HookEvent(AH_EVENT_NEWDAY, OnNewDay, true);
	
	RegAdminCmd("ah_log", LogCmd, ADMFLAG_ROOT);
}

public OnSqlStatusChanged(Handle:hSQL) {
	TryCreateLog();
}

stock bool:CanQuery() {
	return g_hFile == INVALID_HANDLE && AH_GetSQL() != INVALID_HANDLE;
}

stock bool:TryCreateLog(day = 0, month = 0, year = 0, bool:AfterCmd = false, admin = 0)
{
	if (!(g_bAfterCmd = AfterCmd) && !CanQuery()) {
		return false;
	}
	
	if (!day) // Если дата не указана, то считаем что нам нужна дата вчерашнего дня.
	{
		new timestamp = AH_GetTime() - 86400;
		decl String:s[32];
		FormatTime(s, sizeof(s), "%Y", timestamp);
		year  = StringToInt(s);
		FormatTime(s, sizeof(s), "%m", timestamp);
		month = StringToInt(s);
		FormatTime(s, sizeof(s), "%d", timestamp);
		day   = StringToInt(s);
	}
	
	decl String:sDate[16]; // "число.месяц.год"
	FormatEx(sDate, sizeof(sDate), "%02d.%02d.%d", day, month, year);
	
	if (!AfterCmd && !SetTrieValue(g_hIgnoreDateTrie, sDate, 1, false)) { // лог за этот день уже создавали
		return false;
	}
	
	FormatEx(g_sFilePath, sizeof(g_sFilePath), "cfg/activity_history/log/%d%02d%02d.log", year, month, day);
	if (FileExists(g_sFilePath)) // лог за этот день уже создавали
	{
		PrintToConsole(admin, "%d%02d%02d.log already exist", year, month, day);
		return false;
	}
	
	if ((g_hFile = OpenFile(g_sFilePath, "wt")) == INVALID_HANDLE)
	{
		LogError("Can't open %s", g_sFilePath);
		PrintToConsole(admin, "Can't open %s", g_sFilePath);
		return false;
	}
	
	g_AdminId = admin > 0 ? GetClientUserId(admin) : 0;
	
	if (!AH_GetActivityPlayers(sDate, sDate, GetActivityPlayers_Func, true))
	{
		CloseHandle(g_hFile);
		g_hFile = INVALID_HANDLE;
		DeleteFile(g_sFilePath);
		LogError("AH_GetActivityPlayers error (%s)", sDate);
		PrintToConsole(admin, "AH_GetActivityPlayers error (%s)", sDate);
		return false;
	}
	
	return true;
}

public GetActivityPlayers_Func(UniquePlayers, Handle:hAr, const String:DateFrom[], const String:DateTo[], Float:fQuerySeconds, const String:sQueryError[])
{
	new PlayersCount = 0;
	
	if (g_hFile != INVALID_HANDLE)
	{
		new count = hAr == INVALID_HANDLE ? 0 : GetArraySize(hAr);
		if (count > 0)
		{
			decl String:s[128], String:b[6][32], SUM_S, T_S, CT_S, SPEC_S;
			for (new i = 0, hInt, cnt, x, chr; i < count; i++)
			{
				GetArrayString(hAr, i, s, sizeof(s)); // "year|month|day|hDetailAr"
				if (ExplodeString(s, "|", b, sizeof(b), sizeof(b[])) == 4 && (hInt = StringToInt(b[3])) != 0)
				{
					if ((cnt = GetArraySize(Handle:hInt)) > 0)
					{
						for (x = 0; x < cnt; x++)
						{
							GetArrayString(Handle:hInt, x, s, sizeof(s)); // "SUM_SEC|T_SEC|CT_SEC|SPEC_SEC|name|steamid"
							if (ExplodeString(s, "|", b, sizeof(b), sizeof(b[])) == 6)
							{
								TrimString(b[4]); // name
								TrimString(b[5]); // steamid
								chr		= b[5][0];
								SUM_S	= StringToInt(b[0]);
								T_S		= StringToInt(b[1]);
								CT_S	= StringToInt(b[2]);
								SPEC_S	= StringToInt(b[3]);
								
								if (WriteFileLine(g_hFile, "%03d. %02dh:%02dm:%02ds (t: %02dh:%02dm:%02ds, ct: %02dh:%02dm:%02ds, spec: %02dh:%02dm:%02ds), %s, STEAM_0:%c:%s",
									(x+1),
									(SUM_S / 3600 % 24), (SUM_S / 60 % 60), (SUM_S % 60),
									(T_S / 3600 % 24), (T_S / 60 % 60), (T_S % 60),
									(CT_S / 3600 % 24), (CT_S / 60 % 60), (CT_S % 60),
									(SPEC_S / 3600 % 24), (SPEC_S / 60 % 60), (SPEC_S % 60),
									b[4],
									chr, b[5][1]))
								{
									PlayersCount++;
								}
							}
						}
					}
					CloseHandle(Handle:hInt);
				}
			}
		}
		
		CloseHandle(g_hFile);
		g_hFile = INVALID_HANDLE;
		
		if (PlayersCount < 1) {
			DeleteFile(g_sFilePath);
		}
	}
	
	if (hAr != INVALID_HANDLE) {
		CloseHandle(hAr);
	}
	
	if (g_AdminId > 0)
	{
		new admin = GetClientOfUserId(g_AdminId);
		g_AdminId = 0;
		if (admin > 0)
		{
			if (UniquePlayers > 0)
			{
				new d, m, y;
				GetDayMonthYearFromString(DateFrom, d, m, y);
				PrintToConsole(admin, "%d%02d%02d.log successfully created (%d players) (query sec: %.3f)", y, m, d, UniquePlayers, fQuerySeconds);
			}
			else {
				PrintToConsole(admin, "%s (%d players) (query sec: %.3f)", DateFrom, UniquePlayers, fQuerySeconds);
			}
		}
	}
	
	if (!g_bAfterCmd)
	{
		Call_StartForward(g_hAH_OnLogCreated);
		Call_PushString(g_sFilePath);
		Call_PushCell(PlayersCount);
		Call_Finish();
	}
}

/////

public OnNewDay(day_number, day, month, year, old_day, old_month, old_year)
{
	new Handle:hPack = CreateDataPack();
	WritePackCell(hPack, old_day);
	WritePackCell(hPack, old_month);
	WritePackCell(hPack, old_year);
	CreateTimer(1.0, OnNewDay_TIMER, hPack, TIMER_REPEAT|TIMER_DATA_HNDL_CLOSE);
}

public Action:OnNewDay_TIMER(Handle:timer, any:hPack)
{
	ResetPack(hPack);
	new old_day   = ReadPackCell(hPack);
	new old_month = ReadPackCell(hPack);
	new old_year  = ReadPackCell(hPack);
	return TryCreateLog(old_day, old_month, old_year) ? Plugin_Stop : Plugin_Continue;
}

/////

public Action:LogCmd(admin, args)
{
	if (args != 1)
	{
		PrintToConsole(admin, "ah_log \"date\"");
		return Plugin_Handled;
	}
	
	if (!CanQuery())
	{
		PrintToConsole(admin, "Query not finished or MYSQL connection error (wait)");
		return Plugin_Handled;
	}
	
	decl String:sDate[24];
	GetCmdArg(1, sDate, sizeof(sDate));
	new d, m, y;
	if (!GetDayMonthYearFromString(sDate, d, m, y)) // "day.month.year"
	{
		PrintToConsole(admin, "Invalid date");
		return Plugin_Handled;
	}
	
	if (TryCreateLog(d, m, y, true, admin) && admin < 1) {
		PrintToConsole(admin, "If data exists, then will be created %d%02d%02d.log", y, m, d);
	}
	
	return Plugin_Handled;
}